## tellico 3.3

=== CMakeLists.txt ===
# FindKF5 requires CMake >= 2.8.12
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(Tellico)
set(TELLICO_VERSION "3.3")

set(QT_MIN_VERSION "5.4.0")

# FindPoppler was added to ECM in 5.19
find_package(ECM 5.19 REQUIRED NO_MODULE)

CMAKE_POLICY(SET CMP0028 OLD)
if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif(POLICY CMP0063)

# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/Useful-Variables
# automatically add CMAKE_CURRENT_SOURCE_DIR and CMAKE_CURRENT_BINARY_DIR
# to the include directories in every processed CMakeLists.txt
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${ECM_MODULE_PATH}
                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

#include(ECMAddTests)
#include(ECMMarkNonGuiExecutable)
#include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMUninstallTarget)
include(FeatureSummary)

include(KDEInstallDirs)
#include(KDECompilerSettings)
include(KDEFrameworkCompilerSettings)
include(KDECMakeSettings)

############# Options #################

option(ENABLE_CDTEXT       "Enable cdtext" TRUE)
option(ENABLE_WEBCAM       "Enable support for webcams" FALSE)
option(BUILD_FETCHER_TESTS "Build tests which verify data sources" FALSE)

include(CheckSymbolExists)
check_symbol_exists(strlwr "string.h" HAVE_STRLWR)
check_symbol_exists(strupr "string.h" HAVE_STRUPR)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core
    Widgets
    Xml
    DBus
    Test
    Network
)

find_package(KF5 REQUIRED COMPONENTS
    Archive
    Codecs
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DocTools
    GuiAddons
    IconThemes
    ItemModels
    I18n
    JobWidgets
    KIO
    Solid
    Wallet
    WidgetsAddons
    WindowSystem
    XmlGui
)
find_package(KF5KHtml REQUIRED NO_MODULE)

include(MacroBoolTo01)

find_package(Gettext REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

find_package(KF5FileMetaData)
set_package_properties(KF5FileMetaData PROPERTIES
    DESCRIPTION "Support for reading file metadata"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF5NewStuff)
set_package_properties(KF5NewStuff PROPERTIES
    DESCRIPTION "Support for fetching new templates and scripts"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF5Sane)
set_package_properties(KF5Sane PROPERTIES
    DESCRIPTION "Support for adding scanned images to a collection"
    URL "https://www.kde.org"
    TYPE OPTIONAL)
if(KF5Sane_FOUND)
    include_directories(${KF5Sane_INCLUDE_DIR})
endif(KF5Sane_FOUND)

#macro_optional_find_package(KdepimLibs 4.5)
#macro_log_feature(KDEPIMLIBS_FOUND "kdepimlibs" "Support for using the address book and calendar for loans" "https://community.kde.org/PIM" FALSE "4.5.0" "")
#find_package(KdepimLibs 4.5)
#set_package_properties(KdepimLibs PROPERTIES
#    DESCRIPTION "Support for using the address book and calendar for loans"
#    URL "https://community.kde.org/PIM"
#    TYPE OPTIONAL)
if(KDEPIMLIBS_FOUND)
    include_directories(${KDEPIMLIBS_INCLUDE_DIRS})
endif(KDEPIMLIBS_FOUND)

# There is a port of libkcddb to use KF5 style linking and headers
find_package(KF5Cddb)
set_package_properties(KF5Cddb PROPERTIES
    DESCRIPTION "Support for CDDB searches"
    URL "https://cgit.kde.org/libkcddb.git"
    TYPE OPTIONAL)

find_package(Taglib)
set_package_properties(Taglib PROPERTIES
    DESCRIPTION "Support for reading multimedia files"
    URL "https://taglib.org/"
    TYPE OPTIONAL)
if(TAGLIB_FOUND)
    add_definitions(${TAGLIB_CFLAGS})
    include_directories(${TAGLIB_INCLUDES})
endif(TAGLIB_FOUND)

find_package(Yaz 2.0)
set_package_properties(Yaz PROPERTIES
    DESCRIPTION "Support for searching z39.50 databases"
    URL "https://www.indexdata.com/resources/software/yaz/"
    TYPE OPTIONAL)
if(Yaz_FOUND)
    include_directories(${Yaz_INCLUDE_DIRS})
endif(Yaz_FOUND)

# FindPoppler is part of ECM >= 5.19
find_package(Poppler COMPONENTS Qt5)

find_package(Exempi 2.0)
set_package_properties(Exempi PROPERTIES
    DESCRIPTION "Support for reading PDF/XMP metadata"
    URL "https://libopenraw.freedesktop.org/exempi/"
    TYPE OPTIONAL)
if(Exempi_FOUND)
    include_directories(${Exempi_INCLUDE_DIRS})
endif(Exempi_FOUND)

find_package(Btparse)
set_package_properties(Btparse PROPERTIES
    DESCRIPTION "External support for parsing and processing BibTeX data files"
    URL "https://metacpan.org/release/Text-BibTeX"
    TYPE OPTIONAL)
if(Btparse_FOUND)
    include_directories(${Btparse_INCLUDE_DIRS})
    set(TELLICO_BTPARSE_LIBS ${Btparse_LIBRARIES})
else(Btparse_FOUND)
    set(TELLICO_BTPARSE_LIBS btparse-tellico)
endif(Btparse_FOUND)

find_package(CDIO)
set_package_properties(CDIO PROPERTIES
    DESCRIPTION "Support for reading cdtext from audio CDs"
    URL "https://www.gnu.org/software/libcdio/"
    TYPE OPTIONAL)
if(CDIO_FOUND)
    include_directories(${CDIO_INCLUDE_DIRS})
endif(CDIO_FOUND)

find_package(Csv 3.0)
set_package_properties(Csv PROPERTIES
    DESCRIPTION "External support for reading CSV files"
    URL "http://sourceforge.net/projects/libcsv/"
    TYPE OPTIONAL)
if(Csv_FOUND)
    include_directories(${Csv_INCLUDE_DIRS})
    set(TELLICO_CSV_LIBS ${Csv_LIBRARIES})
else(Csv_FOUND)
    set(TELLICO_CSV_LIBS csv-tellico)
endif(Csv_FOUND)

# webcam uses libv4l, which only works on Linux for now
# Linux 2.6.38 removed the videodev.h header
# libv4l 0.8.3 includes a compat header for videodev.h
if(ENABLE_WEBCAM)
    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        message("WARNING: Webcam support is not available on your platform")
        set( ENABLE_WEBCAM FALSE )
    else(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        pkg_check_modules(LIBV4L libv4l1>=0.6)
        #macro_log_feature(LIBV4L_FOUND "libv4l" "Support for barcode scanning with a webcam" "https://hansdegoede.livejournal.com/3636.html"  FALSE "" "")
        set_package_properties(LIBV4L PROPERTIES
            DESCRIPTION "Support for barcode scanning with a webcam"
            URL "https://hansdegoede.livejournal.com/3636.html"
            TYPE OPTIONAL)
        if(LIBV4L_FOUND)
            if(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                message("WARNING: libv4l 0.8.3 or later is required for Linux kernel 2.6.38 or later")
                set( ENABLE_WEBCAM FALSE )
            else(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                include_directories(${LIBV4L_INCLUDE_DIR})
            endif(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
        else(LIBV4L_FOUND)
            set(ENABLE_WEBCAM FALSE)
        endif(LIBV4L_FOUND)
    endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
endif(ENABLE_WEBCAM)

if(CMAKE_COMPILER_IS_GNUCXX)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wextra -fno-check-new -Woverloaded-virtual")
    # remove -Wno-deprecated when porting to KF5 is more advanced
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -fno-check-new -Woverloaded-virtual -Wno-deprecated -Wno-deprecated-declarations")
endif(CMAKE_COMPILER_IS_GNUCXX)

#add_definitions(${QT_DEFINITIONS}
#                ${KDE4_DEFINITIONS}
#                ${YAZ_CFLAGS})
add_definitions(-DQT_STL -DQT_NO_CAST_FROM_ASCII -DQT_NO_URL_CAST_FROM_STRING)
remove_definitions(-DQT_NO_STL)

include_directories(${LIBXML2_INCLUDE_DIR}
                    ${LIBXSLT_INCLUDE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${Tellico_SOURCE_DIR}/src/config
                    ${Tellico_SOURCE_DIR}/src/3rdparty)

set(TELLICO_DATA_INSTALL_DIR ${KDE_INSTALL_DATADIR}/tellico)

add_subdirectory(src)
add_subdirectory(icons)
add_subdirectory(xslt)
add_subdirectory(doc)

########## Wrap tests results around the tests done within the source

macro_bool_to_01(TAGLIB_FOUND HAVE_TAGLIB)
macro_bool_to_01(Poppler_Qt5_FOUND HAVE_POPPLER)
macro_bool_to_01(Exempi_FOUND HAVE_EXEMPI)
macro_bool_to_01(Yaz_FOUND HAVE_YAZ)
macro_bool_to_01(KF5Sane_FOUND HAVE_KSANE)
macro_bool_to_01(Libkcddb_FOUND HAVE_KCDDB)
macro_bool_to_01(KF5Cddb_FOUND HAVE_KF5KCDDB)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KABC)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KCAL)
macro_bool_to_01(LIBV4L_FOUND HAVE_V4L)
macro_bool_to_01(KF5NewStuff_FOUND ENABLE_KNEWSTUFF3)
macro_bool_to_01(Btparse_FOUND HAVE_LIBBTPARSE)
macro_bool_to_01(CDIO_FOUND HAVE_CDIO)
macro_bool_to_01(Csv_FOUND HAVE_LIBCSV)
macro_bool_to_01(KF5FileMetaData_FOUND HAVE_KFILEMETADATA)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

########### install files ###############

install(PROGRAMS org.kde.tellico.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES tellico.dtd tellico.tips DESTINATION ${TELLICO_DATA_INSTALL_DIR})
install(FILES tellico.xml DESTINATION  ${KDE_INSTALL_MIMEDIR})
install(FILES org.kde.tellico.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== debian/changelog ===
tellico (3.3-2ubuntu1) groovy; urgency=medium

  * Temporarily make build time tests non fatal.

 -- Rik Mills <rikmills@kde.org>  Thu, 30 Apr 2020 15:37:22 +0100

tellico (3.3-2) unstable; urgency=medium

  * Backport upstream commit ab305dd0d8b720c8e01dae8a66f6527442fb73f1 to fix
    the ISO 5426 decoder on architectures where char is unsigned; patch
    upstream_Account-for-QByteArray-at-returning-char-not-uchar.patch.

 -- Pino Toscano <pino@debian.org>  Sun, 26 Apr 2020 23:59:29 +0200

tellico (3.3-1) unstable; urgency=medium

  * New upstream release:
    - the SHA-related sources were dropped (Closes: #775589)
  * Update watch file to the new archive location/layout.
  * Update the patches:
    - tests-no-network.diff: update to simply mark network as always
      unavailable
  * Backport upstream commit aee9e90c1ce0257d12ea85029435db8ffa65a6a1 to build
    with Qt < 5.14; patch upstream_Use-unnamespaced-hex-for-Qt-5.14.patch.
  * Backport upstream commit a5dec9e16a0972107a39e76caaea170c03dd276e to
    harmonize the return value of TitleComparison::compare on Qt < 5.14 to what
    newer Qt versions do.
  * Switch the Python scripts to Python 3:
    - add the dh-python, and python3:any build dependencies
    - use the python3 dh addon
    - invoke dh_python3 on the proper data directory in tellico-scripts
    - use the ${python3:Depends} substvar in tellico-scripts, removing the
      manual python suggest
  * Bump Standards-Version to 4.5.0, no changes required.
  * Recommend kio-extras for file previews. (Closes: #945872)

 -- Pino Toscano <pino@debian.org>  Thu, 23 Apr 2020 10:50:27 +0200

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-undefined -Wl,--as-needed
# do not use kdeinit for kio
export KDE_FORK_SLAVES=1

%:
	dh $@ --with kf5,python3

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- \
		-DENABLE_WEBCAM=false

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && $(MAKE) install DESTDIR=$(CURDIR)/test_root
	$(eval TESTS_HOME := $(shell mktemp -d --tmpdir tellico-home.XXXXXX))
	mkdir -p "$(TESTS_HOME)/tmp"
	mkdir -p -m 700 "$(TESTS_HOME)/runtime"
	-xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
	rm -rf "$(TESTS_HOME)"
endif

override_dh_auto_install:
	dh_auto_install
	# extra copyright notices
	rm -fv debian/tmp/usr/share/tellico/pics/README.*

override_dh_missing:
	dh_missing --fail-missing

override_dh_python3:
	dh_python3 -p tellico-scripts --shebang=/usr/bin/python3 /usr/share/tellico/data-sources

## tellico 3.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.3")
+set(TELLICO_VERSION "3.3.1")
 
 set(QT_MIN_VERSION "5.4.0")

=== src/tests/CMakeLists.txt ===
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)

SET( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

# formattest includes fieldformat that include core/tellico_config.h
# which is generated in the build directory
INCLUDE_DIRECTORIES( ${Tellico_BINARY_DIR}/src )

add_executable(entitytest entitytest.cpp ../fieldformat.cpp)
ecm_mark_nongui_executable(entitytest)
add_test(entitytest entitytest)
ecm_mark_as_test(entitytest)
TARGET_LINK_LIBRARIES(entitytest utils config Qt5::Test )

add_executable(cuecattest cuecattest.cpp)
ecm_mark_nongui_executable(cuecattest)
add_test(cuecattest cuecattest)
ecm_mark_as_test(cuecattest)
TARGET_LINK_LIBRARIES(cuecattest utils Qt5::Test)

add_executable(isbntest isbntest.cpp)
ecm_mark_nongui_executable(isbntest)
add_test(isbntest isbntest)
ecm_mark_as_test(isbntest)
TARGET_LINK_LIBRARIES(isbntest utils Qt5::Test)

add_executable(lccntest lccntest.cpp)
ecm_mark_nongui_executable(lccntest)
add_test(lccntest lccntest)
ecm_mark_as_test(lccntest)
TARGET_LINK_LIBRARIES(lccntest utils Qt5::Test)

add_executable(lcctest lcctest.cpp ../field.cpp ../fieldformat.cpp)
ecm_mark_nongui_executable(lcctest)
add_test(lcctest lcctest)
ecm_mark_as_test(lcctest)
TARGET_LINK_LIBRARIES(lcctest tellicomodels Qt5::Test)

add_executable(formattest formattest.cpp ../fieldformat.cpp)
ecm_mark_nongui_executable(formattest)
add_test(formattest formattest)
ecm_mark_as_test(formattest)
TARGET_LINK_LIBRARIES(formattest config Qt5::Test)

add_executable(fieldtest fieldtest.cpp ../field.cpp ../fieldformat.cpp ../gui/urlfieldlogic.cpp)
ecm_mark_nongui_executable(fieldtest)
add_test(fieldtest fieldtest)
ecm_mark_as_test(fieldtest)
TARGET_LINK_LIBRARIES(fieldtest config utils Qt5::Test)

add_executable(imagetest imagetest.cpp ../utils/tellico_utils.cpp ../utils/guiproxy.cpp ../utils/cursorsaver.cpp ../fieldformat.cpp)
ecm_mark_nongui_executable(imagetest)
add_test(imagetest imagetest)
ecm_mark_as_test(imagetest)
TARGET_LINK_LIBRARIES(imagetest images KF5::Archive Qt5::Test)

add_executable(imagejobtest imagejobtest.cpp ../fieldformat.cpp)
ecm_mark_nongui_executable(imagejobtest)
add_test(imagejobtest imagejobtest)
ecm_mark_as_test(imagejobtest)
TARGET_LINK_LIBRARIES(imagejobtest images KF5::Archive Qt5::Test)

add_executable(iso6937test iso6937test.cpp)
ecm_mark_nongui_executable(iso6937test)
add_test(iso6937test iso6937test)
ecm_mark_as_test(iso6937test)
TARGET_LINK_LIBRARIES(iso6937test utils Qt5::Test)

add_executable(iso5426test iso5426test.cpp)
ecm_mark_nongui_executable(iso5426test)
add_test(iso5426test iso5426test)
ecm_mark_as_test(iso5426test)
TARGET_LINK_LIBRARIES(iso5426test utils Qt5::Test)

SET(tellicotest_SRCS
   ../collection.cpp
   ../entry.cpp
   ../entrygroup.cpp
   ../entrycomparison.cpp
   ../field.cpp
   ../fieldformat.cpp
   ../filter.cpp
   ../borrower.cpp
   ../collectionfactory.cpp
   ../derivedvalue.cpp
   ../progressmanager.cpp
)

add_library(tellicotest STATIC ${tellicotest_SRCS})
TARGET_LINK_LIBRARIES(tellicotest Qt5::Core Qt5::Gui KF5::I18n KF5::ConfigWidgets)

ADD_DEPENDENCIES(tellicotest tellico_config)

SET(translatorstest_SRCS
  ../translators/tellicoimporter.cpp
  ../translators/xsltimporter.cpp
  ../translators/textimporter.cpp
  ../translators/dataimporter.cpp
  ../translators/importer.cpp
  ../translators/tellicoxmlhandler.cpp
  ../translators/tellico_xml.cpp
  ../translators/xmlstatehandler.cpp
  ../translators/xslthandler.cpp
)

add_library(translatorstest STATIC ${translatorstest_SRCS})
TARGET_LINK_LIBRARIES(translatorstest
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::Xml
  KF5::I18n
  KF5::Archive
  KF5::KIOWidgets
  KF5::ConfigWidgets
  ${LIBXML2_LIBRARIES}
  ${LIBXSLT_LIBRARIES}
  ${LIBXSLT_EXSLT_LIBRARIES}
)

set(TELLICO_TEST_LIBS
   tellicotest
   collections
   utils
   images
   core
   tellicomodels
   Qt5::Test
   KF5::KIOCore
   KF5::Archive
)

add_executable(collectiontest collectiontest.cpp
  ../document.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(collectiontest)
add_test(collectiontest collectiontest)
ecm_mark_as_test(collectiontest)
TARGET_LINK_LIBRARIES(collectiontest translatorstest ${TELLICO_TEST_LIBS})

add_executable(comparisontest comparisontest.cpp)
ecm_mark_nongui_executable(comparisontest)
add_test(comparisontest comparisontest)
ecm_mark_as_test(comparisontest)
TARGET_LINK_LIBRARIES(comparisontest tellicotest tellicomodels Qt5::Test)

add_executable(documenttest documenttest.cpp
  ../document.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(documenttest)
add_test(documenttest documenttest)
ecm_mark_as_test(documenttest)
TARGET_LINK_LIBRARIES(documenttest translatorstest ${TELLICO_TEST_LIBS})

add_executable(filtertest filtertest.cpp)
ecm_mark_nongui_executable(filtertest)
add_test(filtertest filtertest)
ecm_mark_as_test(filtertest)
TARGET_LINK_LIBRARIES(filtertest gui ${TELLICO_TEST_LIBS})

add_executable(tellicomodeltest tellicomodeltest.cpp modeltest.cpp
  ../document.cpp
  ../translators/tellicoimporter.cpp
  ../translators/dataimporter.cpp
  ../translators/importer.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
  ../translators/tellicoxmlhandler.cpp
  ../translators/tellico_xml.cpp
  ../translators/xmlstatehandler.cpp
)
ecm_mark_nongui_executable(tellicomodeltest)
add_test(tellicomodeltest tellicomodeltest)
ecm_mark_as_test(tellicomodeltest)
TARGET_LINK_LIBRARIES(tellicomodeltest ${TELLICO_TEST_LIBS} ${LIBXML2_LIBRARIES})

######################################################

add_executable(adstest adstest.cpp
  ../translators/adsimporter.cpp
  ../translators/importer.cpp
)
ecm_mark_nongui_executable(adstest)
add_test(adstest adstest)
ecm_mark_as_test(adstest)
TARGET_LINK_LIBRARIES(adstest ${TELLICO_TEST_LIBS})

add_executable(alexandriatest alexandriatest.cpp
  ../translators/alexandriaimporter.cpp
  ../translators/importer.cpp
  ../translators/alexandriaexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(alexandriatest)
add_test(alexandriatest alexandriatest)
ecm_mark_as_test(alexandriatest)
TARGET_LINK_LIBRARIES(alexandriatest ${TELLICO_TEST_LIBS})

add_executable(amctest amctest.cpp
  ../translators/amcimporter.cpp
  ../translators/dataimporter.cpp
  ../translators/importer.cpp
)
ecm_mark_nongui_executable(amctest)
add_test(amctest amctest)
ecm_mark_as_test(amctest)
TARGET_LINK_LIBRARIES(amctest ${TELLICO_TEST_LIBS})

IF( TAGLIB_FOUND )

add_executable(audiofiletest audiofiletest.cpp
  ../translators/audiofileimporter.cpp
  ../translators/dataimporter.cpp
  ../translators/importer.cpp
)
ecm_mark_nongui_executable(audiofiletest)
add_test(audiofiletest audiofiletest)
ecm_mark_as_test(audiofiletest)
TARGET_LINK_LIBRARIES(audiofiletest ${TELLICO_TEST_LIBS} ${TAGLIB_LIBRARIES})

ENDIF( TAGLIB_FOUND )

add_executable(bibtextest bibtextest.cpp
  ../translators/bibteximporter.cpp
  ../translators/importer.cpp
  ../translators/bibtexexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(bibtextest)
add_test(bibtextest bibtextest)
ecm_mark_as_test(bibtextest)
TARGET_LINK_LIBRARIES(bibtextest ${TELLICO_BTPARSE_LIBS} ${TELLICO_TEST_LIBS})

add_executable(bibtexmltest bibtexmltest.cpp
  ../translators/bibtexmlimporter.cpp
  ../translators/bibtexmlexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(bibtexmltest)
add_test(bibtexmltest bibtexmltest)
ecm_mark_as_test(bibtexmltest)
TARGET_LINK_LIBRARIES(bibtexmltest translatorstest core ${TELLICO_TEST_LIBS})

add_executable(citetest citetest.cpp
  ../collections/bibtexcollection.cpp
  ../core/filehandler.cpp
)
ecm_mark_nongui_executable(citetest)
add_test(citetest citetest)
ecm_mark_as_test(citetest)
TARGET_LINK_LIBRARIES(citetest cite tellicotest config images Qt5::Test)
ADD_DEPENDENCIES(citetest tellico_config)

add_executable(ciwtest ciwtest.cpp
  ../translators/ciwimporter.cpp
  ../translators/importer.cpp
)
ecm_mark_nongui_executable(ciwtest)
add_test(ciwtest ciwtest)
ecm_mark_as_test(ciwtest)
TARGET_LINK_LIBRARIES(ciwtest ${TELLICO_TEST_LIBS})

add_executable(csvtest csvtest.cpp
  ../translators/csvparser.cpp
  ../translators/csvexporter.cpp
  ../translators/exporter.cpp
)
ecm_mark_nongui_executable(csvtest)
add_test(csvtest csvtest)
ecm_mark_as_test(csvtest)
TARGET_LINK_LIBRARIES(csvtest ${TELLICO_CSV_LIBS} translatorstest ${TELLICO_TEST_LIBS})

add_executable(delicioustest delicioustest.cpp
  ../translators/deliciousimporter.cpp
)
ecm_mark_nongui_executable(delicioustest)
add_test(delicioustest delicioustest)
ecm_mark_as_test(delicioustest)
TARGET_LINK_LIBRARIES(delicioustest rtf2html-tellico translatorstest ${TELLICO_TEST_LIBS})

add_executable(filelistingtest filelistingtest.cpp
  ../translators/filelistingimporter.cpp
  ../translators/xmphandler.cpp
)
ecm_mark_nongui_executable(filelistingtest)
add_test(filelistingtest filelistingtest)
ecm_mark_as_test(filelistingtest)
TARGET_LINK_LIBRARIES(filelistingtest
  translatorstest
  ${TELLICO_TEST_LIBS}
  KF5::Solid
)
IF( KF5FileMetaData_FOUND )
  TARGET_LINK_LIBRARIES(filelistingtest KF5::FileMetaData)
ENDIF( KF5FileMetaData_FOUND )
IF( Exempi_FOUND )
  TARGET_LINK_LIBRARIES(filelistingtest ${Exempi_LIBRARIES})
ENDIF( Exempi_FOUND )

add_executable(gcstartest gcstartest.cpp
  ../translators/gcstarimporter.cpp
  ../translators/gcstarexporter.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
  ../document.cpp
)
ecm_mark_nongui_executable(gcstartest)
add_test(gcstartest gcstartest)
ecm_mark_as_test(gcstartest)
TARGET_LINK_LIBRARIES(gcstartest translatorstest ${TELLICO_TEST_LIBS})

add_executable(griffithtest griffithtest.cpp
  ../translators/griffithimporter.cpp
)
ecm_mark_nongui_executable(griffithtest)
add_test(griffithtest griffithtest)
ecm_mark_as_test(griffithtest)
TARGET_LINK_LIBRARIES(griffithtest translatorstest ${TELLICO_TEST_LIBS})

add_executable(htmlexportertest htmlexportertest.cpp
  ../translators/htmlexporter.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
  ../document.cpp
)
ecm_mark_nongui_executable(htmlexportertest)
add_test(htmlexportertest htmlexportertest)
ecm_mark_as_test(htmlexportertest)
TARGET_LINK_LIBRARIES(htmlexportertest translatorstest ${TELLICO_TEST_LIBS})

add_executable(modstest modstest.cpp)
ecm_mark_nongui_executable(modstest)
add_test(modstest modstest)
ecm_mark_as_test(modstest)
TARGET_LINK_LIBRARIES(modstest translatorstest ${TELLICO_TEST_LIBS})

add_executable(referencertest referencertest.cpp
  ../translators/referencerimporter.cpp
)
ecm_mark_nongui_executable(referencertest)
add_test(referencertest referencertest)
ecm_mark_as_test(referencertest)
TARGET_LINK_LIBRARIES(referencertest translatorstest ${TELLICO_TEST_LIBS})

add_executable(ristest ristest.cpp
  ../translators/risimporter.cpp
  ../translators/importer.cpp
)
ecm_mark_nongui_executable(ristest)
add_test(ristest ristest)
ecm_mark_as_test(ristest)
TARGET_LINK_LIBRARIES(ristest ${TELLICO_TEST_LIBS})

add_executable(tellicoreadtest tellicoreadtest.cpp
  ../translators/tellicoxmlexporter.cpp
  ../translators/tellicozipexporter.cpp
  ../translators/exporter.cpp
  ../document.cpp
)
ecm_mark_nongui_executable(tellicoreadtest)
add_test(tellicoreadtest tellicoreadtest)
ecm_mark_as_test(tellicoreadtest)
TARGET_LINK_LIBRARIES(tellicoreadtest translatorstest ${TELLICO_TEST_LIBS})

add_executable(vinoxmltest vinoxmltest.cpp
  ../translators/vinoxmlimporter.cpp
)
ecm_mark_nongui_executable(vinoxmltest)
add_test(vinoxmltest vinoxmltest)
ecm_mark_as_test(vinoxmltest)
TARGET_LINK_LIBRARIES(vinoxmltest translatorstest ${TELLICO_TEST_LIBS})

SET(fetcherstest_SRCS
  ../fetch/fetcher.cpp
  ../fetch/fetcherjob.cpp
  ../fetch/fetchresult.cpp
  ../fetch/fetchmanager.cpp

=== debian/changelog ===
tellico (3.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Use-unnamespaced-hex-for-Qt-5.14.patch: drop, backported from
      upstream
    - upstream_Normalize-return-value-of-TitleComparison-compare.patch: drop,
      backported from upstream
    - upstream_Account-for-QByteArray-at-returning-char-not-uchar.patch: drop,
      backported from upstream

 -- Pino Toscano <pino@debian.org>  Tue, 02 Jun 2020 00:25:31 +0200

=== debian/control ===
Source: tellico
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 12),
 , cmake, extra-cmake-modules
 , pkg-config, pkg-kde-tools, qtbase5-dev
 , libkf5archive-dev
 , libkf5cddb-dev
 , libkf5codecs-dev
 , libkf5config-dev
 , libkf5configwidgets-dev
 , libkf5coreaddons-dev
 , libkf5crash-dev
 , libkf5doctools-dev
 , libkf5filemetadata-dev
 , libkf5guiaddons-dev
 , libkf5khtml-dev
 , libkf5i18n-dev
 , libkf5iconthemes-dev
 , libkf5itemmodels-dev
 , libkf5jobwidgets-dev
 , libkf5kio-dev
 , libkf5newstuff-dev
 , libkf5sane-dev
 , libkf5solid-dev
 , libkf5wallet-dev
 , libkf5widgetsaddons-dev
 , libkf5windowsystem-dev
 , libkf5xmlgui-dev
 , libtag1-dev, libyaz-dev, libpoppler-qt5-dev
 , libexempi-dev, libcsv-dev, libbtparse-dev
 , libcdio-dev
 , gettext
 , xvfb, xauth, kio
 , python3:any, dh-python
Build-Conflicts: libqimageblitz-dev
Standards-Version: 4.5.0
Homepage: https://tellico-project.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git

Package: tellico
Breaks: tellico-data (<< 3.1-0.1~)
Replaces: tellico-data (<< 3.1-0.1~)
Architecture: any
Depends: tellico-data (= ${source:Version})
 , tellico-scripts (>= ${source:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends: tellico-doc, kio-extras
Description: Collection manager for books, videos, music, etc
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.

Package: tellico-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: tellico, khelpcenter
Description: Collection manager for books, videos, music, etc [doc]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the documentation.

Package: tellico-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [data]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the architecture independent files, such data files and
 documentation.

Package: tellico-scripts
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [scripts]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the scripts to import data from external sources, such
 as websites. As the format of the data may change, these scripts are provided
 as a separate package which can be updated through debian-volatile.

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	$(eval TESTS_HOME := $(shell mktemp -d --tmpdir tellico-home.XXXXXX))
 	mkdir -p "$(TESTS_HOME)/tmp"
 	mkdir -p -m 700 "$(TESTS_HOME)/runtime"
-	-xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
+	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
 	rm -rf "$(TESTS_HOME)"
 endif

## tellico 3.3.2

=== debian/changelog ===
tellico (3.3.2-1build1) groovy; urgency=medium

  * Rebuild against new libcdio19.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Aug 2020 09:36:34 +0200

tellico (3.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop the Debian man page, as it offers no useful information over the
    --help output.
  * Add Rules-Requires-Root: no.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_missing, as it is the default now

 -- Pino Toscano <pino@debian.org>  Sat, 08 Aug 2020 12:37:15 +0200

## tellico 3.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.3.1")
+set(TELLICO_VERSION "3.3.3")
 
 set(QT_MIN_VERSION "5.4.0")
 
@@ -20,8 +20,8 @@
 set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
-                      ${ECM_MODULE_PATH}
-                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
+                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
+                      ${ECM_MODULE_PATH})
 
 #include(ECMAddTests)
 #include(ECMMarkNonGuiExecutable)

=== debian/changelog ===
tellico (3.3.3-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Tue, 15 Sep 2020 07:29:10 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  , cmake, extra-cmake-modules
  , pkg-config, pkg-kde-tools, qtbase5-dev
  , libkf5archive-dev
@@ -37,6 +37,7 @@
  , python3:any, dh-python
 Build-Conflicts: libqimageblitz-dev
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://tellico-project.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git

=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,5 @@
 	# extra copyright notices
 	rm -fv debian/tmp/usr/share/tellico/pics/README.*
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_python3:
 	dh_python3 -p tellico-scripts --shebang=/usr/bin/python3 /usr/share/tellico/data-sources

## tellico 3.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.3.3")
+set(TELLICO_VERSION "3.3.4")
 
 set(QT_MIN_VERSION "5.4.0")

=== xslt/CMakeLists.txt ===
ADD_SUBDIRECTORY( entry-templates )
ADD_SUBDIRECTORY( report-templates )

########### install files ###############

SET(XSLT_FILES
    arxiv2tellico.xsl
    biblioshare2tellico.xsl
    bibtexml2tellico.xsl
    bluray-logo.png
    boardgamegeek2tellico.xsl
    cassette-logo.png
    comicvine2tellico.xsl
    cd-logo.png
    crossref2tellico.xsl
    dbc2tellico.xsl
    dblp2tellico.xsl
    delicious2tellico.xsl
    dvd-logo.png
    dvdfr2tellico.xsl
    gcstar2tellico.xsl
    giantbomb2tellico.xsl
    goodreads2tellico.xsl
    griffith2tellico.xsl
    hddvd-logo.png
    MARC21slim2MODS3.xsl
    MARC21slimUtils.xsl
    mods2tellico.xsl
    musicbrainz2tellico.xsl
    pubmed2tellico.xsl
    record-logo.png
    referencer2tellico.xsl
    shadowAlpha.png
    springer2tellico.xsl
    srw2tellico.xsl
    tellico2gcstar.xsl
    tellico2html.js
    tellico2html.xsl
    tellico2onix.xsl
    tellico-by-author.xsl
    tellico-by-title.xsl
    tellico-common.xsl
    tellico-printing.xsl
    UNIMARC2MODS3.xsl
    unixref2tellico.xsl
    vhs-logo.png
    vinoxml2tellico.xsl
    welcome.html
    xmp2tellico.xsl
    )

INSTALL(FILES ${XSLT_FILES} DESTINATION ${TELLICO_DATA_INSTALL_DIR} )

=== src/3rdparty/CMakeLists.txt ===
IF( NOT Btparse_FOUND )
  ADD_SUBDIRECTORY( btparse )
ENDIF( NOT Btparse_FOUND )

IF( NOT Csv_FOUND )
  ADD_SUBDIRECTORY( libcsv )
ENDIF( NOT Csv_FOUND )

ADD_SUBDIRECTORY( rtf2html )

=== debian/changelog ===
tellico (3.3.4-2) unstable; urgency=medium

  * Backport upstream commit c879fa89ea143545c1c6a29f1e1d68c33dee334b to fix
    comparisontest in years after 2020; patch
    upstream_Fix-data-comparison-test-for-2021.patch. (Closes: #980695)
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Thu, 21 Jan 2021 12:12:11 +0100

tellico (3.3.4-1) unstable; urgency=medium

  [ Pino Toscano ]
  * New upstream release.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Fix day-of-week for changelog entries 1.2.11-1, 1.0.3+SVNr327-1.

  [ Vagrant Cascadian ]
  * Disable fixfilepath feature, as it triggers build failures when enabled.
    (Closes: #972295)

 -- Pino Toscano <pino@debian.org>  Thu, 26 Nov 2020 18:39:00 +0100

## tellico 3.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.3.4")
+set(TELLICO_VERSION "3.3.5")
 
 set(QT_MIN_VERSION "5.4.0")

=== src/CMakeLists.txt ===
ADD_SUBDIRECTORY( core )
ADD_SUBDIRECTORY(config )
ADD_SUBDIRECTORY( gui )
ADD_SUBDIRECTORY( collections )
ADD_SUBDIRECTORY( images )
ADD_SUBDIRECTORY( translators )
ADD_SUBDIRECTORY( fetch )
ADD_SUBDIRECTORY( commands )
ADD_SUBDIRECTORY( cite )
ADD_SUBDIRECTORY( newstuff )
ADD_SUBDIRECTORY( models )
ADD_SUBDIRECTORY( utils )
ADD_SUBDIRECTORY( 3rdparty )

IF( BUILD_TESTING )
  ADD_SUBDIRECTORY( tests )
ENDIF( BUILD_TESTING )

IF( ENABLE_WEBCAM )
  ADD_SUBDIRECTORY( barcode )
ENDIF( ENABLE_WEBCAM )

########### next target ###############

set(ICONS_PNG
  ${CMAKE_SOURCE_DIR}/icons/16-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/22-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/32-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/48-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/64-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/128-apps-tellico.png
)

ecm_add_app_icon(ICONS_SOURCES ICONS ${ICONS_PNG})

SET(tellico_SRCS
   ${ICONS_SOURCES}
   bibtexkeydialog.cpp
   borrower.cpp
   borrowerdialog.cpp
   collection.cpp
   collectionfactory.cpp
   collectionfieldsdialog.cpp
   configdialog.cpp
   controller.cpp
   dbusinterface.cpp
   detailedlistview.cpp
   derivedvalue.cpp
   document.cpp
   entry.cpp
   entryeditdialog.cpp
   entrygroup.cpp
   entryiconview.cpp
   entrycomparison.cpp
   entrymatchdialog.cpp
   entrymerger.cpp
   entryupdatejob.cpp
   entryupdater.cpp
   entryview.cpp
   exportdialog.cpp
   fetchdialog.cpp
   fetcherconfigdialog.cpp
   field.cpp
   fieldcompletion.cpp
   fieldformat.cpp
   filter.cpp
   filterdialog.cpp
   filterview.cpp
   groupview.cpp
   importdialog.cpp
   loandialog.cpp
   loanview.cpp
   main.cpp
   mainwindow.cpp
   progressmanager.cpp
   reportdialog.cpp
   tellico_kernel.cpp
   viewstack.cpp
   )

qt5_add_resources(tellico_SRCS
   ../icons/icons.qrc
)

add_executable(tellico ${tellico_SRCS})

TARGET_LINK_LIBRARIES(tellico
    core
    cite
    fetch
    collections
    images
    translators
    gui
    commands
    tellicomodels
    utils
    newstuff
    rtf2html-tellico
    ${TELLICO_BTPARSE_LIBS}
    ${TELLICO_CSV_LIBS}
    )

TARGET_LINK_LIBRARIES(tellico
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
    KF5::Crash
    KF5::KHtml
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::WindowSystem
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
    )

IF( KF5NewStuff_FOUND )
  TARGET_LINK_LIBRARIES(tellico KF5::NewStuff)
ENDIF( KF5NewStuff_FOUND )

IF( KDEPIMLIBS_FOUND )
  TARGET_LINK_LIBRARIES(tellico KF5::Contacts ${KDEPIMLIBS_KCAL_LIBS} KF5::AkonadiContact)
ENDIF( KDEPIMLIBS_FOUND )

IF( KF5Cddb_FOUND )
  TARGET_LINK_LIBRARIES(tellico KF5::Cddb)
ELSEIF( Libkcddb_FOUND )
  TARGET_LINK_LIBRARIES(tellico KDE::Libkcddb::kcddb)
ENDIF( KF5Cddb_FOUND)

IF( Exempi_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${Exempi_LIBRARIES})
ENDIF( Exempi_FOUND )

IF( TAGLIB_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${TAGLIB_LIBRARIES})
ENDIF( TAGLIB_FOUND )

IF( Yaz_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${Yaz_LIBRARIES})
ENDIF( Yaz_FOUND )

IF( ENABLE_WEBCAM )
  TARGET_LINK_LIBRARIES(tellico barcode ${LIBV4L_LIBRARIES})
ENDIF( ENABLE_WEBCAM )

IF( KF5Sane_FOUND )
  TARGET_LINK_LIBRARIES(tellico KF5::Sane)
ENDIF( KF5Sane_FOUND )

########### install files ###############

INSTALL(TARGETS tellico ${INSTALL_TARGETS_DEFAULT_ARGS} )
INSTALL(FILES tellicorc DESTINATION ${KDE_INSTALL_CONFDIR} )
INSTALL(FILES tellicoui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/tellico )

=== src/config/CMakeLists.txt ===
########### next target ###############

SET(config_STAT_SRCS
   tellico_config_addons.cpp
   )

SET(config_KCFG_SRCS
   tellico_config.kcfgc
   )

kconfig_add_kcfg_files(config_STAT_SRCS ${config_KCFG_SRCS})

ADD_CUSTOM_TARGET(tellico_config DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/tellico_config.h)

add_library(config STATIC ${config_STAT_SRCS})

TARGET_LINK_LIBRARIES(config
    Qt5::Core
    KF5::I18n
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::ConfigWidgets
    )

########### install files ###############

INSTALL(FILES   tellico_config.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR} )
INSTALL(FILES   tellico-rename.upd tellico.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

INSTALL(PROGRAMS   tellico-1-3-update.pl DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

=== src/fetch/CMakeLists.txt ===
ADD_SUBDIRECTORY( scripts )

########### next target ###############

SET(fetch_STAT_SRCS
   allocinefetcher.cpp
   amazonfetcher.cpp
   amazonrequest.cpp
   animenfofetcher.cpp
   arxivfetcher.cpp
   bedethequefetcher.cpp
   bibliosharefetcher.cpp
   bibsonomyfetcher.cpp
   boardgamegeekfetcher.cpp
   colnectfetcher.cpp
   comicvinefetcher.cpp
   configwidget.cpp
   crossreffetcher.cpp
   dbcfetcher.cpp
   dblpfetcher.cpp
   discogsfetcher.cpp
   doubanfetcher.cpp
   dvdfrfetcher.cpp
   entrezfetcher.cpp
   execexternalfetcher.cpp
   fetcher.cpp
   fetcherinfolistitem.cpp
   fetcherinitializer.cpp
   fetcherjob.cpp
   fetchmanager.cpp
   fetchresult.cpp
   filmasterfetcher.cpp
   gcstarpluginfetcher.cpp
   gcstarthread.cpp
   giantbombfetcher.cpp
   googlebookfetcher.cpp
   googlescholarfetcher.cpp
   hathitrustfetcher.cpp
   ibsfetcher.cpp
   igdbfetcher.cpp
   imdbfetcher.cpp
   isbndbfetcher.cpp
   kinofetcher.cpp
   kinopoiskfetcher.cpp
   kinoteatrfetcher.cpp
   messagehandler.cpp
   messagelogger.cpp
   mobygamesfetcher.cpp
   moviemeterfetcher.cpp
   mrlookupfetcher.cpp
   multifetcher.cpp
   musicbrainzfetcher.cpp
   omdbfetcher.cpp
   openlibraryfetcher.cpp
   springerfetcher.cpp
   srufetcher.cpp
   thegamesdbfetcher.cpp
   themoviedbfetcher.cpp
   videogamegeekfetcher.cpp
   vndbfetcher.cpp
   xmlfetcher.cpp
   z3950connection.cpp
   z3950fetcher.cpp
   )

add_library(fetch STATIC ${fetch_STAT_SRCS})

TARGET_LINK_LIBRARIES(fetch
    newstuff
    utils
    ${TELLICO_BTPARSE_LIBS}
    Qt5::Network
    KF5::Archive
    KF5::IconThemes
    KF5::JobWidgets
    KF5::KIOWidgets
    )

IF(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")
  TARGET_LINK_LIBRARIES(fetch
      KF5::KIOGui
      )
ENDIF(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")

IF( Yaz_FOUND )
  TARGET_LINK_LIBRARIES(fetch ${Yaz_LIBRARIES})
ENDIF( Yaz_FOUND )

########### install files ###############

INSTALL(FILES z3950-servers.cfg DESTINATION ${TELLICO_DATA_INSTALL_DIR} )

=== src/images/CMakeLists.txt ===
SET(images_STAT_SRCS
   image.cpp
   imagedirectory.cpp
   imagefactory.cpp
   imageinfo.cpp
   imagejob.cpp
   )

add_library(images STATIC ${images_STAT_SRCS})

TARGET_LINK_LIBRARIES(images
    core
    config
    utils
    KF5::KIOCore
    KF5::Archive
    KF5::GuiAddons
    Qt5::Gui
)

ADD_DEPENDENCIES(images tellico_config)

=== src/newstuff/CMakeLists.txt ===
########### next target ###############

SET(newstuff_STAT_SRCS
   manager.cpp
   )

qt5_add_dbus_adaptor(newstuff_STAT_SRCS org.kde.tellico.newstuff.xml manager.h Tellico::NewStuff::Manager)

add_library(newstuff STATIC ${newstuff_STAT_SRCS})

TARGET_LINK_LIBRARIES(newstuff
    utils
    Qt5::Core
    Qt5::Gui
    KF5::ConfigCore
    KF5::KIOCore
    KF5::Archive
    )

IF( KF5NewStuff_FOUND )
  INSTALL(FILES tellico-template.knsrc tellico-script.knsrc DESTINATION ${KDE_INSTALL_CONFDIR})
endif()

=== xslt/entry-templates/CMakeLists.txt ===
########### install files ###############

INSTALL(FILES   Default.xsl Video.xsl Album.xsl Fancy.xsl Compact.xsl DESTINATION ${TELLICO_DATA_INSTALL_DIR}/entry-templates )

=== debian/changelog ===
tellico (3.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Fix-data-comparison-test-for-2021.patch: drop, backported from
      upstream

 -- Pino Toscano <pino@debian.org>  Wed, 24 Feb 2021 15:14:13 +0100

=== debian/control ===
--- 
+++ 
@@ -36,7 +36,7 @@
  , xvfb, xauth, kio
  , python3:any, dh-python
 Build-Conflicts: libqimageblitz-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://tellico-project.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+# The fixfilepath feature causes a build failure, disable it.
+export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-undefined -Wl,--as-needed
 # do not use kdeinit for kio
 export KDE_FORK_SLAVES=1

=== debian/watch ===
version=4
https://tellico-project.org/archive \
https://tellico-project.org/(?:wp-content/uploads/\.\./\.\./)?files/@PACKAGE@-([\d.]+)\.tar\.xz
